$(document).ready(function () {
    $("#start_date").datepicker({dateFormat: 'yy/mm/dd', changeMonth: true, changeYear: true, maxDate: 0});
    $("#end_date").datepicker({dateFormat: 'yy/mm/dd', changeMonth: true, changeYear: true, maxDate: 0});
    $('#date_range').on('change', function (e) {
        var valueSelected = this.value;
        if (valueSelected == "single") {
            $('#start_date').addClass('hidden');
            $('#end_date').attr('placeholder', 'Date');
			} else {
            $('#start_date').removeClass('hidden');
            $('#end_date').attr('placeholder', 'To date');
		}
	});
    $('#report_option').on('change', function (e) {
        var valueSelected = this.value;
        if (valueSelected == "summary") {
            flip_display('detailed', 'summary');
			} else {
            flip_display('summary', 'detailed');
            render_detailed();
		}
	});
    date_search('now');
});
jQuery.extend({
    getValues: function (file_name) {
        var result = null;
        $.ajax({
            url: file_name,
            dataType: 'json',
            async: false,
            success: function (data, textstatus, xhr) {
                result = data;
			},
            error: function () {
                putlog("error: load handler failed: " + file_name);
                result = null;
			}
		});
        return result;
	}
});
function date_search($option) {
    //container_display(dashboard);
	
    $('.container-data').addClass('hidden');
	
    if ($('#dashboard').hasClass('hidden'))
	$('#dashboard').removeClass('hidden');
    if ($('#summary').hasClass('hidden'))
	$('#summary').removeClass('hidden');
    if (!$('#detailed').hasClass('hidden'))
	$('#detailed').addClass('hidden');
	
    $("#report_option").val('summary');
    denied_sites = '';
	
    if ($option === "now") {
        d = new Date();
        $base_path = [
            d.getFullYear(),
            ('0' + (d.getMonth() + 1)).slice(-2),
            ('0' + d.getDate()).slice(-2)
		].join('/');
        $date_from = '-';
        $date_end = $base_path;
		} else {
		
        report_type = $('#date_range').val();
        if (report_type == "single") {
            $date_from = '-';
            $date_end = $("#end_date").val();
			} else {
            $date_from = $("#start_date").val();
            $date_end = $("#end_date").val();
		}
		
	}
	
    QUERY_type = 'summary';
    QUERY = '&args=3&arg_1=START_TIME&val_1=' + $date_from + '&arg_2=END_TIME&val_2=' + $date_end + '&arg_3=type&val_3=' + QUERY_type;
    $handler = 'http://safesquid.cfg/?handler=generic_script_handler&script_to_execute=report.py' + QUERY;
    $summary_ = $($.getValues($handler));
    $summary = $summary_[0];
    $('.hrs_detail').html('-');
    $('#tot_bw').html(formatBytes($summary["bw"]));
    $('#browsed_usr').html($summary["us"]);
    $('#browsed_site').html($summary["al"]);
    $('#blocked_site').html($summary["bl"]);	
	
    interval = $summary["ha"];
    for (var i = 0,
	len = interval.length; i < len; i++) {
        $this_tm = interval[i]["interval"];
        $('#global_hour #int_' + $this_tm + '_bw').html(formatBytes(interval[i]["bw"]));
        $('#global_hour #int_' + $this_tm + '_rq').html(interval[i]["rq"]);
	}
	
    delete $summary_;
    delete $summary;
    delete interval;
	
	QUERY_type = 'new_sites';
    QUERY = '&args=3&arg_1=START_TIME&val_1=' + $date_from + '&arg_2=END_TIME&val_2=' + $date_end + '&arg_3=type&val_3=' + QUERY_type;
    $handler = 'http://safesquid.cfg/?handler=generic_script_handler&script_to_execute=report.py' + QUERY;
    $new_sites = $($.getValues($handler));	
	
	$('#new_site').html($new_sites.length);
	
    QUERY_type = 'user';
    QUERY = '&args=3&arg_1=START_TIME&val_1=' + $date_from + '&arg_2=END_TIME&val_2=' + $date_end + '&arg_3=type&val_3=' + QUERY_type;
    $handler = 'http://safesquid.cfg/?handler=generic_script_handler&script_to_execute=report.py' + QUERY;
    $user_ = $($.getValues($handler));
    $user_content = $user_[0]['content'];
	
    $user_list_ = "data/user.json";
    $website_list_ = "data/sites.json";
	
    $user_list = $($.getValues($user_list_))[0];
    $website_list = $($.getValues($website_list_))[0];
	
    QUERY_type = 'user';
    QUERY = '&args=3&arg_1=START_TIME&val_1=' + $date_from + '&arg_2=END_TIME&val_2=' + $date_end + '&arg_3=type&val_3=' + QUERY_type;
    $handler = 'http://safesquid.cfg/?handler=generic_script_handler&script_to_execute=report.py' + QUERY;
    $user_ = $($.getValues($handler));
    $user_content = $user_[0]['content'];
	
    var $top_users = [];
    for (var key in $user_content) {
        $top_users.push([
            $user_list[key],
            $user_content[key].rq,
            formatBytes($user_content[key].bw)
		]);
	}
	
    var table = $('#table_top_users').DataTable({
        destroy: true,
        pageLength: 10,
        data: $top_users,
        dom: "rt",
        deferLoading: 2,
        columnDefs: [
            {
                type: 'file-size',
                targets: 2
			}
		],
        order: [
            [2, "desc"]
		]
	});
	
    QUERY_type = 'allowed_site';
    QUERY = '&args=3&arg_1=START_TIME&val_1=' + $date_from + '&arg_2=END_TIME&val_2=' + $date_end + '&arg_3=type&val_3=' + QUERY_type;
    $handler = 'http://safesquid.cfg/?handler=generic_script_handler&script_to_execute=report.py' + QUERY;
    allwd_sites = $($.getValues($handler));
	
    allowed_sites = [];
	
    for (var i = 0,
	len = allwd_sites.length; i < len; i++) {
        sites_allow = $website_list[allwd_sites[i]["url"]];
        if (!sites_allow)
		sites_allow_ = 'unknown';
        else
		sites_allow_ = $website_list[allwd_sites[i]["url"]];
		
        allowed_sites.push([
            sites_allow_,
            allwd_sites[i]["rq"],
            formatBytes(allwd_sites[i]["bw"])
		]);
	}
	
    var top_sites_table = $('#table_top_sites').DataTable({
        destroy: true,
        pageLength: 10,
        data: allowed_sites,
        deferLoading: 2,
        dom: "rt",
        columnDefs: [
            {
                type: 'file-size',
                targets: 2
			}
		],
        order: [
            [2, "desc"]
		]
	});
	
}

function render_detailed() {
	
    user_details_ = $user_content;
    allowed_src = [];
	
    $.each(user_details_, function (key, user_details) {
        $data_time = '<span class="fa fa-search MIcon cursor" onclick="container_display(\'user_details\');user_detail(\'' + key + '\')"></span>' + $user_list[key];
        allowed_src.push([
            $data_time,
            user_details['rq'],
            timeconversion(user_details['tm']),
            formatBytes(user_details['bw']),
            formatBytes(user_details['dw']),
            formatBytes(user_details['ul']),
            user_details['al'],
            user_details['bl']
		]);
	});
	
    $('#table_det_users').DataTable({
        data: allowed_src,
        destroy: true,
        pageLength: 25,
        columnDefs: [
            {
                width: "20%",
                targets: 0
				}, {
                width: "10%",
                targets: 7
				}, {
                type: 'file-size',
                targets: 3
				}, {
                type: 'file-size',
                targets: 4
				}, {
                type: 'file-size',
                targets: 5
			}
		],
        order: [
            [3, "desc"]
		],
        dom: 'lBfrtip',
        autoWidth: true,
        info: true,
        buttons: [
            {
                extend: 'pdf',
                text: '<span class="fa fa-file-pdf-o"></span>',
                header: true,
                orientation: 'landscape',
                pageSize: 'LEGAL',
                footer: true,
                customize: function (doc) {
                    doc.defaultStyle.fontSize = 12; //<-- set fontsize to 12 instead of 10
				}
				}, {
                extend: 'excel',
                text: '<span class="fa fa-file-excel-o"></span>',
                footer: true
			},
            'copy'
		]
		
	});
	
}

function user_detail(user_id) {
    $('#user_name').html($user_list[user_id]);
    $user_detail = $user_content[user_id];
	
    $('#user_info_bt').html(timeconversion($user_detail['tm']));
    $('#user_info_bw').html(formatBytes($user_detail['bw']));
    $('#user_info_dw').html(formatBytes($user_detail['dw']));
    $('#user_info_ul').html(formatBytes($user_detail['ul']));
    $('#user_info_bs').html($user_detail['al']);
    $('#user_info_blk').html($user_detail['bl']);
	
    interval = $user_detail['ha'];
	
    for (var i = 0,
	len = interval.length; i < len; i++) {
        $this_tm = interval[i]["int"];
        $('#user_details #int_' + $this_tm + '_bw').html(formatBytes(interval[i]["bw"]));
        $('#user_details #int_' + $this_tm + '_rq').html(interval[i]["rq"]);
	}
	
    allowed = $user_detail['allow'];
    allowed_sites = [];
	
    for (var i = 0,
	len = allowed.length; i < len; i++) {
        allowed_sites.push([
            $website_list[allowed[i]["al"]],
            allowed[i]["rq"],
            formatBytes(allowed[i]["bw"])
		]);
	}
	
    $('#allow_user_sites').DataTable({
        data: allowed_sites,
        destroy: true,
        pageLength: 25,
        columnDefs: [
            {
                type: 'file-size',
                targets: 2
			}
		],
        order: [
            [2, "desc"]
		],
        dom: 'lBfrtip',
        autoWidth: true,
        info: true,
        buttons: [
            {
                extend: 'pdf',
                text: '<span class="fa fa-file-pdf-o"></span>',
                header: true,
                orientation: 'landscape',
                pageSize: 'LEGAL',
                footer: true,
                customize: function (doc) {
                    doc.defaultStyle.fontSize = 12; //<-- set fontsize to 12 instead of 10
				}
				}, {
                extend: 'excel',
                text: '<span class="fa fa-file-excel-o"></span>',
                footer: true
			},
            'copy'
		]
		
	});
	
    blocked = $user_detail['blocked'];
	
    allowed_sites = [];
	
    for (var i = 0,
	len = blocked.length; i < len; i++) {
        allowed_sites.push([
            $website_list[blocked[i]["bl"]],
            blocked[i]["rq"],
            formatBytes(blocked[i]["bw"]),
            blocked[i]["fn"]
		]);
	}
	
    $('#block_user_sites').DataTable({
        data: allowed_sites,
        destroy: true,
        pageLength: 25,
        columnDefs: [
            {
                type: 'file-size',
                targets: 2
			}
		],
        order: [
            [2, "desc"]
		],
        dom: 'lBfrtip',
        autoWidth: true,
        info: true,
        buttons: [
            {
                extend: 'pdf',
                text: '<span class="fa fa-file-pdf-o"></span>',
                header: true,
                orientation: 'landscape',
                pageSize: 'LEGAL',
                footer: true,
                customize: function (doc) {
                    doc.defaultStyle.fontSize = 12; //<-- set fontsize to 12 instead of 10
				}
				}, {
                extend: 'excel',
                text: '<span class="fa fa-file-excel-o"></span>',
                footer: true
			},
            'copy'
		]
		
	});
	
}

function show_sites(type) {
    if ($.fn.DataTable.isDataTable('#all_allowed_sites')) {
        $('#all_allowed_sites').DataTable().destroy();
        $('#all_allowed_sites').empty();
	}
    ;
    $('#sites_user').addClass('hidden');
    //$('#all_allowed_sites').DataTable({destroy: true});
    $('#type_heading_site').html('');
    $('#all_allowed_sites thead').html('');
    //$('#all_allowed_sites tbody').html('');
	
	
    if (type == "allowed_site") {
        sites = allwd_sites;
		} else if (type == "new_sites"){
		sites = $new_sites;
		}else {
        if (!denied_sites) {
            QUERY_type = type;
            QUERY = '&args=3&arg_1=START_TIME&val_1=' + $date_from + '&arg_2=END_TIME&val_2=' + $date_end + '&arg_3=type&val_3=' + QUERY_type;
            $handler = 'http://safesquid.cfg/?handler=generic_script_handler&script_to_execute=report.py' + QUERY;
            denied_sites = $($.getValues($handler));
		}
        sites = denied_sites;
	}
	
	
    allowed_sites = [];
	
    if (type == "allowed_site") {
        for (var i = 0,
		len = sites.length; i < len; i++) {
            sites_allow = $website_list[sites[i]["url"]];
            if (!sites_allow)
			sites_allow_ = '<span class="fa fa-search MIcon cursor" onclick="user_know(\'' + sites[i]["url"] + '\',\'allow\',\'al\')"></span>unknown';
            else
			sites_allow_ = '<span class="fa fa-search MIcon cursor" onclick="user_know(\'' + sites[i]["url"] + '\',\'allow\',\'al\')"></span>' + $website_list[sites[i]["url"]];
            allowed_sites.push([
                sites_allow_,
                sites[i]["rq"],
                formatBytes(sites[i]["bw"])/*,
                sites[i]["pro"]
				*/
			]);
		}
		
        $HEAD = '<tr>';
        $HEAD += '<td class="left-align width_60">Web-site</td>';
        $HEAD += '<td class="right-align width_10">Hits</td>';
        $HEAD += '<td class="right-align width_10">Bandwidth</td>';
        //$HEAD += '<td class="right-align width_20">Profiles</td>';
        $HEAD += '</tr>';
		
        HEADING = "ACCESSED SITE";
		
        sourceCols = [
            {
                title: 'Web-site'
				}, {
                title: 'Hits'
				}, {
                title: 'Bandwidth'
				}/*, {
                title: 'Profile'
			}*/
		];
		
		}else if (type == "new_sites"){
		
		
		
		$HEAD = '<tr>';
        $HEAD += '<td class="left-align">Web-site</td>';        
		$HEAD += '<td class="left-align">Request</td>';        
		$HEAD += '<td class="left-align">Bandwidth</td>'; 
        $HEAD += '</tr>';
		
        HEADING = "NEW SITE";
		
		for (var i = 0,
		len = sites.length; i < len; i++) {
            sites_allow = $website_list[sites[i]];
			content = _.findWhere(allwd_sites, {'url': sites[i]});
			if(typeof content === "undefined")
			content = _.findWhere(denied_sites, {'url': sites[i]});
			
			if (typeof content !== "undefined") {
				request = content["rq"];
				bandwidth = content["bw"];
			}else{
				request = 0;
				bandwidth = 0;
			}
			
            if (!sites_allow)
			sites_allow_ = '<span class="fa fa-search MIcon cursor" onclick="user_know(\'' + sites[i] + '\',\'both\',\'bl\')"></span>unknown';
			else
			sites_allow_ = '<span class="fa fa-search MIcon cursor" onclick="user_know(\'' + sites[i] + '\',\'both\',\'bl\')"></span>' + sites_allow;
			
			allowed_sites.push([				
				sites_allow_,
				request,
				formatBytes(bandwidth)
			]);
		}
		
		sourceCols = [
            {
                title: 'Web-site'
			}, {
                title: 'Request'
			}, {
                title: 'Bandwidth'
			}
			
		];
		}else {
		
        for (var i = 0,
		len = sites.length; i < len; i++) {
            sites_allow = $website_list[sites[i]["url"]];
            if (!sites_allow)
			sites_allow_ = '<span class="fa fa-search MIcon cursor" onclick="user_know(\'' + sites[i]["url"] + '\',\'blocked\',\'bl\')"></span>unknown';
			else
			sites_allow_ = '<span class="fa fa-search MIcon cursor" onclick="user_know(\'' + sites[i]["url"] + '\',\'blocked\',\'bl\')"></span>' + $website_list[sites[i]["url"]];
			
			allowed_sites.push([
				sites_allow_,
				sites[i]["rq"],
				formatBytes(sites[i]["bw"]),
				sites[i]["fn"]/*,
				sites[i]["pro"]
				*/
			]);
		}
		
        $HEAD = '<tr>';
        $HEAD += '<td class="left-align width_70">Web-site</td>';
        $HEAD += '<td class="right-align width_10">Hits</td>';
        $HEAD += '<td class="right-align width_10">Bandwidth</td>';
        $HEAD += '<td class="right-align width_10">Reason</td>';
        //$HEAD += '<td class="right-align width_10">Profiles</td>';
        $HEAD += '</tr>';
		
        HEADING = "BLOCKED SITE";
		
        sourceCols = [
            {
                title: 'Web-site'
				}, {
                title: 'Hits'
				}, {
                title: 'Bandwidth'
				}, {
                title: 'Reason'
				}/*, {
                title: 'Profiles'
			}*/
		];
		
	}
	
    $('#type_heading_site').html(HEADING);
	
		
		table = $('#all_allowed_sites').DataTable({
			destroy: true,
			data: allowed_sites,
			pageLength: 25,
			"columns": sourceCols,
			columnDefs: [
				{
					type: 'file-size',
					targets: 2
				}
			],
			order: [
				[2, "desc"]
			],
			dom: 'lBfrtip',
			autoWidth: true,
			info: true,
			buttons: [
				{
					extend: 'pdf',
					text: '<span class="fa fa-file-pdf-o"></span>',
					header: true,
					orientation: 'landscape',
					pageSize: 'LEGAL',
					footer: true,
					customize: function (doc) {
						doc.defaultStyle.fontSize = 12; //<-- set fontsize to 12 instead of 10
					}
					}, {
					extend: 'excel',
					text: '<span class="fa fa-file-excel-o"></span>',
					footer: true
				},
				'copy'
			]
			
		});
	
    
    delete allowed_sites;
}

function user_know(sites_id, type, name) {
    user_list = [];
    stats = $user_content;
    user_dir = $user_list;
    $user_info = "";
	
	if(type == "both"){
		_.each(stats, function (statInfo, key) {        
			content = _.findWhere(statInfo["blocked"], {'bl': sites_id});						
			if (typeof content !== "undefined") {				
				$user_info += '<tr><td><span class="fa fa-search MIcon cursor" onclick="container_display(\'user_details\');user_detail(\'' + key + '\')"></span>' + user_dir[key] + '</td><td>'+content["rq"]+'</td><td>'+formatBytes(content["bw"])+'</td></tr>';
			}
		});		
		
		_.each(stats, function (statInfo, key) {        
			content = _.findWhere(statInfo["allow"], {'al': sites_id});						
			if (typeof content !== "undefined") {				
				$user_info += '<tr><td><span class="fa fa-search MIcon cursor" onclick="container_display(\'user_details\');user_detail(\'' + key + '\')"></span>' + user_dir[key] + '</td><td>'+content["rq"]+'</td><td>'+formatBytes(content["bw"])+'</td></tr>';
			}
		});
		
		}else{
		
		_.each(stats, function (statInfo, key) {
			if (name == "al")
			content = _.findWhere(statInfo[type], {'al': sites_id});
			else
			content = _.findWhere(statInfo[type], {'bl': sites_id});
			
			if (typeof content !== "undefined") {
				$user_info += '<tr><td><span class="fa fa-search MIcon cursor" onclick="container_display(\'user_details\');user_detail(\'' + key + '\')"></span>' + user_dir[key] + '</td><td>'+content["rq"]+'</td><td>'+formatBytes(content["bw"])+'</td></tr>';
			}
		});
	}	
    $('#sites_user').removeClass('hidden');
    $('#user_searched tbody').html($user_info)
}






